/*
 * (c) Copyright Adrian Migraso
 *     Under GPL v2 License
 *
 *  This is distributed free and will remain free
 *
 */

/*
 * Description: A Javascript design for http://LyricsPlugin.com lyrics
 *              Will create a videoke style
 *
 * ... are you having fun yet?...
 *
 *
 * Note: below is an assumption CSS
 *
 * <style>
 * .cs_videoke_shaded, .cs_videoke_unshaded {
 *	font-family:verdana any;
 *	margin:0;padding:0;border:0;
 * }
 * .cs_videoke_shaded {
 *	background-color: #0f0;
 *	color: red;
 *	font-weight:bold;
 * }
 * .cs_videoke_unshaded {
 *	background-color: #fff;
 *	color:#000;
 * }
 * </style>
 *
 */

Videoke.prototype.Init = Init;
Videoke.prototype.ShadeCellAt = ShadeCellAt;
Videoke.prototype.UnShadeCellAt = UnShadeCellAt;
Videoke.prototype.SetFreq = SetFreq;
Videoke.prototype.SetFreqLen = SetFreqLen;
Videoke.prototype.GetModeSpan = GetModeSpan;
Videoke.prototype.DoSwitch = DoSwitch;
Videoke.prototype.FreqSwitch = FreqSwitch;
Videoke.prototype.PlayByFreq = PlayByFreq;
Videoke.prototype._playbyfreq = _playbyfreq;
Videoke.prototype.SetFreqByMap = SetFreqByMap;

function Init()
{
	if ( (null == this.lyricsObj) || ("" == this.lyricsObj.innerHTML) )
		this.lyricsObj.innerHTML = "error: null pointer encountered";

	var res_table = "<table style='margin:0;padding:0;border:0' cellspacing='0' cellpadding='0'><tr>";
	var is_break = false;

	for (i in this.lyricsObj.innerHTML) {
		var c = this.lyricsObj.innerHTML[i];
		switch (c) {
		case '<'://start of <br/>
			is_break = true;
			break;
		case '>'://end of <br/>
			is_break = false;
			res_table += "</tr><br/><tr>";
			break;
		default:
			if (is_break) {
				continue;

			} else {
				var v_id = "videoke_cell_x" + this.C_CNT;
				v_id = "id='" + v_id + "' name='" + v_id + "'" + " class='cs_videoke_unshaded'";
				/* create format <td id='v_id' name='v_id' class='cs_videoke_shaded'>c</td> */
				res_table += "<td " + v_id + " >" + c + "</td>";
				++this.C_CNT;
			}

			break;
		}

	}

	res_table += "</tr></table>";

	this.lyricsObj.innerHTML = res_table;
}

function ShadeCellAt(index)
{
	document.getElementById("videoke_cell_x" + index).setAttribute("class", "cs_videoke_shaded");
}

function UnShadeCellAt(index)
{
	document.getElementById("videoke_cell_x" + index).setAttribute("class", "cs_videoke_unshaded");
}

function SetFreq(mode, ms)
{
	if (mode >= this.FREQ_LEN_S)
		return false;

	this.FREQ_LEN_S[mode] = ms;
}

function SetFreqLen(mode, ms)
{
	if (mode >= this.FREQ_LEN)
		return false;

	this.FREQ_LEN[mode] = ms;
}

function GetModeSpan()
{
	return (new Date().getTime() - this.FREQ_LAST_SWITCH);
}

function DoSwitch()
{
	return (this.GetModeSpan() > this.FREQ_LEN_S[this.FREQ_MODE]) ? true : false;
}

function FreqSwitch()
{
	var bSane = (this.FREQ_LEN_S.length == this.FREQ_LEN.length);
	if (! bSane)
		throw "insane FREQ_LEN_S and FREQ_LEN";

	++this.FREQ_MODE;
	if (this.FREQ_MODE >= this.FREQ_LEN_S.length)
		this.FREQ_MODE = 0;

	this.FREQ_LAST_SWITCH = new Date().getTime();
}

function PlayByFreq() {
	this.play_nloop = 0;
	this._playbyfreq();
}

function _playbyfreq()
{
	if (this.play_nloop < this.C_CNT) {
		this.ShadeCellAt(this.play_nloop);
		++this.play_nloop;
		if (this.DoSwitch()) {
			this.FreqSwitch();
		}
		setTimeout(function(thisObj){thisObj._playbyfreq();}, this.FREQ_LEN[this.FREQ_MODE], this);
	}
}

/*
 * str_map format is "[LEN_S in milliseconds][dot][LEN in milliseconds]"
 * str_map example is "1000.24, 1223.34" will play 24ms in 1000ms then switch to 34ms to 1223ms
*/
function SetFreqByMap(str_map)
{
	var map_arr = str_map.split(",");

	this.FREQ_LEN_S = new Array();
	this.FREQ_LEN = new Array();

	var test = "";

	for (i in map_arr) {
		var l = map_arr[i].split(".");

		var bSane = (2 == l.length);
		if (!bSane)
			throw "error: insane str_map at Videoke.SetMap";

		this.FREQ_LEN_S[this.FREQ_LEN_S.length] = Number(l[0]);
		this.FREQ_LEN[this.FREQ_LEN.length] = Number(l[1]);
	}
}

function Videoke()
{
	/* pointer to <div id="lyrics"></div>*/
	this.lyricsObj = document.getElementById("lyrics");

	/* css variables */
	this.SHADEDCSS = "cs_videoke_shaded";
	this.UNSHADEDCSS = "cs_videoke_unshaded";

	/* character count */
	this.C_CNT = 0;

	/* tools */
	this.play_nloop = 0;

	/* frequency control */
	// time duration in milliseconds before switching tempo
	this.FREQ_LEN_S = new Array(2000, 5000);
	// time duration in milliseconds
	this.FREQ_LEN = new Array(100, 400);
	// switch frequency mode
	this.FREQ_MODE = 0;
	// epoch of last switching
	this.FREQ_LAST_SWITCH = new Date().getTime();

	/* init */
	this.Init();
}
